/*
 * 齬
 * 2001ǯ 823
 */

#include <stdio.h>
#define SIZE 10

int L_eq_input(double a[][SIZE])
{
	int n, i, j;

	do {
	    printf("ϢΩμ");
	    printf("(2-%d) ? ", SIZE-1);
	    scanf("%d", &n);
	} while (n < 2 || n > SIZE-1);

	printf("\n");
	for (i = 1; i <=n; i++) {
	    printf("%d   ", i);
	    for (j = 1; j<= n; j++)
	        scanf("%lf", &a[i][j]);
	}
	return n;
}

void L_eq_LU(double a[][SIZE],
             double LU[][SIZE],
             int n)             /* LU ʬ */
{
	int i, j, k;
	double sum;

	for (i = 1; i <= n; i++)
	    LU[i][1] = a[i][1];
	for (j = 2; j <= n; j++)
	    LU[1][j] = a[1][j] / LU[1][1];
	for (j = 2; j <= n; j++) {
	    for (i = j; i <= n; i++) {
	        sum = 0.0;
	        for (k = 1; k < j; k++)
	            sum += LU[i][k]*LU[k][j];
	        LU[i][j] = a[i][j] - sum;
	    }
	    for (i = j+1; i <= n; i++) {
	        sum = 0.0;
	        for (k = 1; k < j; k++)
	            sum += LU[j][k]*LU[k][i];
	        LU[j][i] = (a[j][i] - sum) / LU[j][j];
	    }
	}
}

void L_eq_solve (double LU[][SIZE],
                 double right[SIZE],
                 int n,
                 double x[SIZE])
{
	int i, j;
	double sum = 0.0;

	/*  */
	for (i = 1; i <= n; i++) {
	    sum = right[i];
	    for (j = 1; j < i; j++)
	        sum -= LU[i][j]*right[j];
	    x[i] = sum / LU[i][i];
	}

	/*  */
	for (i = n; i >= 1; i--) {
	    sum = x[i];
	    for (j = i+1; j <= n; j++)
	        sum -= LU[i][j]*x[j];
	    x[i] = sum;
	}
}

main ()
{
	int i, j, n;
	double a[SIZE][SIZE], LU[SIZE][SIZE];
	double right[SIZE];
	double x[SIZE];

	n = L_eq_input(a);
	L_eq_LU(a, LU, n);

	printf("αդ\n");
	for (i = 1; i <= n; i++) {
	    printf("y[%d] = ", i);
	    scanf("%lf", &right[i]);
	}

	printf("LUν\n");
	for (i = 1; i <= n; i++) {
	    for (j = 1; j <= n; j++)
	        printf("%8.4f", LU[i][j]);
	    printf("\n");
	}

	/* η׻ L_eq_solve */
	L_eq_solve(LU, right, n, x);

	printf("ν\n");
	for (i = 1; i <= n; i++) 
	    printf("x[%d] = %8.4f\n", i, x[i]);

}
